﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Media;
using System.Xml;
using System.Xml.Linq;
using Styx.Helpers;
using Styx;
using Styx.Common;

namespace HotkeyPresser
{
    public partial class HotkeyPresserUI : Form
    {
        public HotkeyPresserUI()
        {
            InitializeComponent();
        }

        private HotkeyPresser PG;
        private string Hotkey = PresserSettings.Instance.Hotkey;
        private int Milliseconds = PresserSettings.Instance.Minutes;

        [DllImport("USER32.DLL", CharSet = CharSet.Unicode)]
        public static extern IntPtr FindWindow(string lpClassName,
            string lpWindowName);

        [DllImport("USER32.DLL")]
        public static extern bool SetForegroundWindow(IntPtr hWnd);

        public void Presser()
        {
            PresserSettings.Instance.Load();
            Hotkey = PresserSettings.Instance.Hotkey;
            IntPtr WoWHandle = FindWindow("GxWindowClass", "World of Warcraft");

            if (WoWHandle == IntPtr.Zero)
            {
                MessageBox.Show("Cannot find World of Warcraft window!");
                return;
            }

            SetForegroundWindow(WoWHandle);
            SendKeys.SendWait(Hotkey);
        }

        // Test Button
        private void button1_Click(object sender, EventArgs e)
        {
            PresserSettings.Instance.Hotkey = textBox1.Text;
            PresserSettings.Instance.Minutes = Convert.ToInt32(maskedTextBox1.Text);
            PresserSettings.Instance.Save();
            Presser();
        }

        private void HotkeyPresserUI_Load(object sender, EventArgs e)
        {
            textBox1.Text = Hotkey;
            maskedTextBox1.Text = Milliseconds.ToString();
        }

        private void maskedTextBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            int isNumber = 0;
            e.Handled = !int.TryParse(e.KeyChar.ToString(), out isNumber);
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            PresserSettings.Instance.Hotkey = textBox1.Text;
        }

        private void maskedTextBox1_MaskInputRejected(object sender, MaskInputRejectedEventArgs e)
        {
            PresserSettings.Instance.Minutes = Convert.ToInt32(maskedTextBox1.Text);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            PresserSettings.Instance.Hotkey = textBox1.Text;
            PresserSettings.Instance.Minutes = Convert.ToInt32(maskedTextBox1.Text);
            PresserSettings.Instance.Save();
            Logging.Write(Colors.Lime, "Hotkey: Settings saved.");
            HotkeyPresser HKP = new HotkeyPresser(); 
            HKP.Restart();
        }
    }
}