﻿using Styx;
using Styx.Helpers;
using System;

namespace HotkeyPresser
{
    public class PresserSettings : Settings
    {
        private static PresserSettings _instance;
        private PresserSettings()
            : base(SettingsPath + ".xml")
        {
        }
        private static string SettingsPath
        {
            get
            {
                return string.Format("{0}\\Settings\\HotkeyPresser\\HotkeyPresser_{1}", AppDomain.CurrentDomain.BaseDirectory, StyxWoW.Me.Name);
            }
        }
        public static PresserSettings Instance
        {
            get { return _instance ?? (_instance = new PresserSettings()); }
        }
        [Setting]
        [DefaultValue(5)]
        public int Minutes { get; set; }
        [Setting]
        [DefaultValue("F12")]
        public string Hotkey { get; set; }
    }
}